unit SknTool;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
  private
    { Private declarations }
  public
    { Public declarations }
  end;


 procedure CreateSkn(PathI, PathO : string);


var
  Form1: TForm1;
  Path, PathIn, PathOut: string;
  List: TstringList;


implementation

uses
  Misc, BZip2, datfile;
{$R *.dfm}

procedure GetDirFiles(Dir: string);
var
  SearchRec: TSearchRec;
begin
  if Dir <> '' then
   if FindFirst(Dir + '*.bmp', faAnyFile, SearchRec) = 0 then
    repeat
      Application.ProcessMessages;
      if (SearchRec.name = '.') or (SearchRec.name = '..') then
        continue;
      if (SearchRec.Attr and faDirectory) = 0 then
        begin
         if (SearchRec.Name<>'preview.bmp') then List.Add(dir+SearchRec.Name);
        end
    until
      FindNext(SearchRec) <> 0;
  FindClose(SearchRec);
end;

procedure CreateSkn(PathI, PathO : string);
begin
  List:=TstringList.Create;
  if not DirectoryExists(PathI) and not DirectoryExists(PathO) then Exit;
  If PathI[Length(PathI)]<>'\' then PathI:=PathI+'\';
  If PathO[Length(PathO)]<>'\' then PathO:=PathO+'\';
  GetDirFiles(PathI);
  List.Add(PathI+'skinparam');
  if FileExists(PathI+'updater.ico') then
    List.Add(PathI+'updater.ico');
  CompressFiles(List,PathO);
  List.Clear;
  GetDirFiles(PathO);
  List.Add(PathO+'skinparam');
  if FileExists(PathO+'updater.ico') then
    List.Add(PathO+'updater.ico');
  Save(PathO+'skin.skn',List,true);
  List.Clear;
  List.Add(PathI+'comment');
  List.Add(PathI+'preview.bmp');
  CompressFiles(List,PathO);
  List.Clear;
  List.Add(PathO+'comment');
  List.Add(PathO+'preview.bmp');
  Save(PathO+'skin.l3i',List,true);
  List.Free;
end;

end.
